function [C,R1,R2,R3,R4,Sekce] = Aktivni(Hin)
% Kaskadni synteza PP, aktivni RC obvody s OZ
% C,R - vraci hodnoty soucastek Deliyannisova zapojeni PP , sekci druheho radu
% Sekce - vraci pocet sekci druheho radu

[Hin_ci,Hin_jm] = tfdata(Hin,'v');  % Dostanu z transformovane fce zpet vektory citatele a jmenovatele
[Res,Poly]=residue(Hin_ci,Hin_jm);  % Vypocet polu prenosove fce
for i = length(Poly):-1:1
    if abs(Poly(i)) <= 0.00001   % Predpokladam jen zapornou imag. cast polu (stabilita)
       Poly = Poly(1:i-1,1);      % Sloupcovy vektor polu zkraceny bez nul
    end
end
for i = 1:1:length(Poly)
    if abs(imag(Poly(i))) <= 0.00001   % Predpokladam jen zapornou imag. cast polu (stabilita)
        Poly(i) = real(Poly(i))+0*j;  % Nastaveni nuly imag. pri polu na realne ose a tak Matlabem vypoctene hodne male zbytecne hodnote
    end;
end
Sekce = length(Poly)/2;     % Pocet paru polu, tj. pocet sekci
disp('Poly prenosove fce H(p) :');
disp('-------------------------');
Poly
% Vypocet vychozich parametru z polu podle 8.10
if mod(length(Poly),2) == 1        % Je-li pocet polu lichy, existuje take realny pol
    % U PP by se nemely byt i realne poly
else                    % Je-li sudy
    ii = 1;
    for i = 1:2:length(Poly)
        w_p(ii) = sqrt(real(Poly(i))^2 + imag(Poly(i))^2);   % kmitocet
        Qp(ii) = abs(w_p(ii)/(2*real(Poly(i)))); % Cinitel tvaru
        ii = ii + 1;
    end    
end
disp('Vychozi parametry :');
disp('-------------------');
w_p
Qp
% Vypocet stavebnich prvku
if mod(length(Poly),2) == 1        % Je-li pocet polu lichy, existuje take realny pol
    % U PP by se nemely byt i realne poly
else                    % Je-li sudy
    for i = 1:1:Sekce   % Vypocet stavebnich prvku pro Qp < 5 a Qp < 20 podle 8.23,8.24
        disp(' ');
        disp(['Vypocet ',int2str(i),' sekce :'] );
        disp('------------------------------');
        %disp('Vychozi parametry :');
        %w_p(i)
        %Qp(i)
        C(i) = input('Zvolte hodnotu C = C1 = C2 [nF]: ');
        C(i) = C(i) * 10^(-9);
        if Qp(i) < 5    % Vypocet podle 8.23
            R3(i) = Inf;
            R1(i) = 1/(w_p(i)*C(i)*2*Qp(i));
            R2(i) = 4*R1(i)*Qp(i)^2;
            R4(i) = 0;
        else    % Pro Qp < 20, zapojeni podle obr. 8.11
            R3(i) = input('Zvolte hodnotu R3 [kOhmu]: '); % Vypocet podle 8.24
            R3(i) = R3(i) * 10^3;
            R1(i) = 1/(w_p(i)*C(i)*sqrt(2*Qp(i)));
            R2(i) = 2*R1(i)*Qp(i);
            R4(i) = R3(i)*(1 - 1/sqrt(2*Qp(i)))/Qp(i);
        end
        disp(' ');
        disp(['Stavebni prvky ',int2str(i),' sekce :']);
        disp(['C1 = C2 = ',Prevod(C(i)),'F']);
        disp(['R1 = ',Prevod(R1(i)),'Ohmu']);
        disp(['R2 = ',Prevod(R2(i)),'Ohmu']);
        disp(['R3 = ',Prevod(R3(i)),'Ohmu']);
        disp(['R4 = ',Prevod(R4(i)),'Ohmu']);
    end
end