% ******Cebysevova aproximace******
% ******David Hradecky, 2003******
disp('Cebysevova aproximace');
n = ceil(log(1/k1+sqrt(1/k1^2-1))/log(1/k+sqrt(1/k^2-1)));    % Stupen filtru, zaokrouhleno nahoru na cele cislo, 6.42
disp('Stupen filtru n :');
disp('=================');
n
% Prepocet parametru NDP na n cele
kn = 1/cosh((1/n)*acosh(1/k1));         % Novy pomer meznich kmitoctu
OMEGASn = 1/kn;                         % Novy hranickni kmitocet nepropustneho pasma, 6.44
disp('Hranicni kmitocet nepropustneho pasma :');
OMEGASn
% Parametry standardniho tolerancniho schematu NDP
H_ap = 1/sqrt(1+epsilon^2);
H_as = 1/sqrt(1+epsilon^2/k1^2);
plot([0,OMEGAP,OMEGAP],[H_ap,H_ap,0],'b-',[OMEGASn,OMEGASn,OMEGASn+1],[1,H_as,H_as],'r-');
Title('Standardn tolerann schma NDP');
Xlabel('\Omega');
Ylabel('|H(j\Omega)|');
pause;
% Vypocet pomocnych parametru, hlavni a vedlejsi poloosa elipsy podle 6.55
a = (1/2)*((sqrt(1+1/epsilon^2)+1/epsilon)^(1/n)-(sqrt(1+1/epsilon^2)-1/epsilon)^(1/n));
b = (1/2)*((sqrt(1+1/epsilon^2)+1/epsilon)^(1/n)+(sqrt(1+1/epsilon^2)-1/epsilon)^(1/n));
% Urceni polu prenosove fce H(s),
for i = 1:1:n
    s(i) = -a*sin((2*i-1)*pi/(2*n))+j*b*cos((2*i-1)*pi/(2*n));  % Jen z leve poloroviny podle 6.56
    if abs(imag(s(i))) <= 0.00001   % Predpokladam jen zapornou imag. cast polu (stabilita)
        s(i) = real(s(i))+0*j;  % Nastaveni nuly imag. pri polu na realne ose a tak Matlabem vypoctene hodne male zbytecne hodnote
    end;
end
% Zobrazeni polu na elipse v komplexni rovine
uhel = 0:0.01:6.28; 
for i = 1:1:629
    elipsa(i) = a*sin(uhel(i))+j*b*cos(uhel(i)); % Vykresleni elipsy v kompl. rovine
end
S = zeros(2*n,1); % Pomocny vektor pro vykresleni spojnic polu s nulou
for i = 2:2:2*n
    S(i-1) = s(i/2);
end
plot([-a,a],[0,0],'k-',[0,0],[-b,b],'k-',real(S),imag(S),'c:',real(elipsa),imag(elipsa),'c:',real(s),imag(s),'r*');
axis([-(a+1/(10*a)),a+1/(10*a),-(b+1/(10*b)),b+1/(10*b)]);
%grid; % Mrizka
for i=1:1:n
    text(real(s(i)),imag(s(i))+0.08,num2str(s(i),4),'FontSize',8);  % Zobrazeni hodnot polu
end
Title('Hledan poly penosov funkce, s = \Sigma + j\Omega');
Xlabel('Real[s] = \Sigma');
Ylabel('Imag[s] = j\Omega');
pause;
% Vypocet prenosove funkce H(s) podle 6.58, 6.60 a charakteristicke fce Fi(s) podle 6.65, 6.66
alfa = real(s);
beta = imag(s);
Fi = 1;
if mod(n,2) == 1         % Je-li stupen aproximace n lichy
    m = (n-1)/2;
    H_jm = [1,a];        % Repezentuje (s+a) jmenovatele
    H0 = 1/(epsilon*2^(2*m));
    G = [epsilon*2^(2*m),0]; % Nasobna konstanta charakteristicke fce upraveno pro 6.65
    Gn = [2^(2*m),0];   % pro epsilon=1
else                     % Je-li n sudy
    m = n/2;
    H_jm = 1;
    H0 = 1/(epsilon*2^(2*m-1));
    G = epsilon*2^(2*m-1);  % pro sude se nenasobi s
    Gn = 2^(2*m-1);
end
% Vypocet koeficientu polynomu ve jmenovateli prenosove fce
% Vypocet maxima aproximujici funkce v propustnem pasmu
for i = 1:1:m
    Hp = [1,-2*alfa(i),(alfa(i)^2+beta(i)^2)];    % Zakladni polynom jmenovatele, vztah 6.60
    H_jm = conv(H_jm,Hp);           % Soucin polynomu H_jm*Hp jmenovatele pro n sude a liche
    OMEGA_0(i) = cos((2*i-1)*pi/(2*n)); % Maxima aproximujici funkce v propustnem pasmu
    Fip = [1,0,OMEGA_0(i)^2];       % Reprezentuje (s^2 + OMEGA_0i^2) z vypoctu char.fce 6.65
    Fi = conv(Fi,Fip);
end                                 % Vysledne koef. jsou v H_jm
Gs = G(1)*H_jm;                     % Tj. G(s)=H(s)^(-1)
[H,w] = freqs(H0,H_jm);             % Automaticky vypocet hodnot prenosove fce H(s) pro nekolik omega podle 6.58,6.60
[B,A] = cheby1(n,ap,OMEGAP,'s');    % Pro porovnani vypocet prenosove fce s vyuzitim funkce Matlabu
[H_n,w_n] = freqs(B,A);             % Normovana H(s)
Hc = tf(H0,H_jm);                   % Vysledna prenosova funkce ve tvaru funkce
%plot(w,abs(H),'b-',w_n,abs(H_n),'g-.'); %Srovnani modulovych charakteristik
%pause;
% Graf modulove charakteristiky + tolerancni sch. NDP
subplot(2,1,1);
plot(w,abs(H),'b-',[0,OMEGAP,OMEGAP],[H_ap,H_ap,0],'b:',[OMEGASn,OMEGASn,OMEGASn+1],[1,H_as,H_as],'r:');
axis([0,ceil(OMEGASn)+1,0,1]); % xmin,xmax,ymin,ymax
text(ceil((OMEGAP+(OMEGASn-OMEGAP)/2)*10)/10,0.8,['n = ',int2str(n)]); 
Title('Izoextremln charakteristika modulu penosu NDP (Cebysev)');
Xlabel('\Omega');
Ylabel('|H(j\Omega)|');
epsilon % vypis zakladnich hodnot
H0
disp('Prenosova fce H(s) NDP :');
disp('========================');
Hc
% Dopocitani charakteristicke fce Fi
Fi_Tab = conv(Gn,Fi);   % Pro epsilon=1
Fi = conv(G,Fi);
Tn = Fi_Tab;    % Tabulkove koeficienty Cabysevova polynomu
Fic = tf(Fi,1);              % Vysledna charakteristicka fce Fi(s) ve tvaru funkce
disp('Charakteristicka funkce Fi(s) :');
disp('===============================');
Fic
disp('Tab. Ceb. koeficienty :');
Tn
% Vypocet skutecneho skupinoveho zpozdeni Tau
d_Gs = polyder(Gs); % derivovany polynom G(s)
[Tau,W] = freqs(d_Gs,Gs); % automaticke vycisleni zlomku d_G(s)/G(s) pro nejake kmitocty
Tau = real(Tau);    % Vypoctene skutecne skupinove zpozdeni vychazejici z definice 5.29
subplot(2,1,2);
plot(W,Tau,'b-');
axis([0,ceil(OMEGASn)+1,0,ceil(max(Tau))]); % xmin,xmax,ymin,ymax
text(ceil((OMEGAP+(OMEGASn-OMEGAP)/2)*10)/10,n-0.5,['n = ',int2str(n)]); 
Title('Charakteristika skupinovho zpodn NDP (Cebysev)');
Xlabel('\Omega');
Ylabel('\tau(\Omega)');
pause;
CLF;
% Fazova charakteristika
faze = angle(H);
subplot(2,1,1);
plot(w,(faze),'b-');
axis([0,ceil(OMEGASn)+1,-4,4]);
Xlabel('\Omega');
Ylabel('Faze');
Title('Fzov charakteristika NDP');
pause;

% ***** Realizace, urceni soucastek *****
% Vypocet rozkladem v retezovy zlomek (Cauer), odstepenim polu v nekonecnu
% Pro +Fi podle 5.39
% Vypocet hodnot L a C NDP, pzn. pro n suda vede na nestejne zakonceni filtru
z_ci = Gs + Fi;
z_jm = Gs - Fi;
z_vs = tf(z_ci,z_jm);   % vstup. imp. transformovana do tvaru funkce
while z_jm(1) == 0 % Kdyz po odecteni bude prvni nula ve vektoru tak ji odstranim pred delenim
    z_jm = z_jm(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
[lcx,r2t] = Rozklad(z_ci,z_jm);  % Vlastni rozklad v retezovy zlomek pomoci fce Rozklad postupnym delenim
r1 = 1;
disp(' Vstupni impedance pro +Fi : ');
disp('---------------------------- ');
z_vs
CLF;    % Smazu predchozi grafy
subplot(2,1,1);
Title('Schma filtru NDP, T lnek pro +Fi ');
Schema(lcx,r1,r2t,n,'LC');   % Vykresleni schema zapojeni prickove struktury s prvnim L podelnym

% Pro -Fi podle 5.39
z_ci = Gs - Fi;
z_jm = Gs + Fi;
z_vs = tf(z_ci,z_jm);   % vstup. imp. transformovana do tvaru funkce
while z_ci(1) == 0 % Kdyz po odecteni bude prvni nula ve vektoru tak ji odstranim pred delenim
    z_ci = z_ci(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
[clx,r2p] = Rozklad(z_ci,z_jm); % Tady zaciname pricnym C1
disp(' Vstupni impedance pro -Fi : ');
disp('-----------------------------');
z_vs
subplot(2,1,2);
Title('Schma filtru NDP, \pi lnek pro -Fi ');
Schema(clx,r1,r2p,n,'CL');   % Vykresleni schema zapojeni prickove struktury s prvnim C pricnym
pause;

% Vypocet prenosove funkce PP H(p)
Hc_p = Ftransf(Hc,d_omega,omega_m); % Transformace H(s) na H(p)
disp('Prenosova fce H(p) PP :');
disp('=======================');
Hc_p
[Hcp_ci,Hcp_jm] = tfdata(Hc_p,'v');  % Dostanu z transformovane fce zpet vektory citatele a jmenovatele
%[Hp,wp] = freqs(Hcp_ci,Hcp_jm);      % Automaticky vypocet hodnot prenosove fce H(p)
%f = wp/(2*pi);
sf = ceil(f_s + (fs - f_s)/2);
fpoc = f_s - ceil(sf/5);
if fpoc < 0
   fpoc = 0;
end
fkon = fs + ceil(sf/5);
i = 1;
for f = fpoc+1:fkon/500:fkon    % Vhodne jen pro kmitocty blizke "nule", radove az kHz
    wp(i) = f*2*pi;
    fh(i) = f;
    i = i + 1;
end
Hp = freqs(Hcp_ci,Hcp_jm,wp);   % Vypocet pro vice omega nez to pocita automaticky, protoze je potreba vice hodnot pro H(p) vyssich radu
% Graf modulove charakteristiky H(p)+ tolerancni sch. PP
subplot(2,1,1);
plot(fh,abs(Hp),'b-',[0,f_s,f_s],[H_as,H_as,1],'r:',[f_p,f_p,fp,fp],[0,H_ap,H_ap,0],'b:',[fs,fs,fkon],[1,H_as,H_as],'r:');
axis([fpoc,fkon,0,1]); % xmin,xmax,ymin,ymax
Title('Izoextremln charakteristika modulu penosu PP (Cebysev)');
Xlabel('f [Hz]');
Ylabel('|H(p)|');
% Vypocet skutecneho skupinoveho zpozdeni Tau
[d_G_ci,d_G_jm] = polyder(Hcp_jm,Hcp_ci); % derivovany podil dvou polynomu G(p)=Hbp_jm/Hbp_ci
Tci = conv(d_G_ci,Hcp_ci);    % d_G_ci*H_ci
Tjm = conv(d_G_jm,Hcp_jm);    % d_G_jm*H_jm
%[Tau,W] = freqs(Tci,Tjm);   % automaticke vycisleni zlomku dG(p)/G(p) pro nejake kmitocty
%ft = W/(2*pi);
Tau = freqs(Tci,Tjm,wp);   % Vypocet pro vice omega nez to pocita automaticky, pro vyssi rozliseni
Tau = abs(real(Tau));    % Vypoctene skutecne skupinove zpozdeni vychazejici z definice 5.29
subplot(2,1,2);
plot(fh,Tau,'b-');
axis([fpoc,fkon,0,max(Tau)+max(Tau)/10]); % xmin,xmax,ymin,ymax
Title('Charakteristika skupinovho zpodn PP (Cebysev)');
Xlabel('f [Hz]');
Ylabel('\tau [s]');
pause;
close all	% Zavreni oken s grafy (figure)

% Odnormovani
disp('-----------------------------------');
disp('* Zvolte impedancni uroven obvodu *');
disp('-----------------------------------');
R_0 = input(' Ro = '); % Impedancni uroven
%[LC] = Odnormuj(Soucastky,R0,dW,Wm,Stupen,Struktura)
[LCS] = Odnormuj(lcx,R_0,d_omega,omega_m,n,'LC');   % Odnormovani struktury T s prvnim podelnym L
CLF;    % Smazu predchozi
subplot(2,1,1);
Title(['Schma filtru T po odnormovn pro Ro = ',int2str(R_0),' \Omega']);
Schema(LCS,R_0,R_0*r2t,n,'LS');   % Vykresleni schema zapojeni prickove struktury s prvni LC seriove
[LCP] = Odnormuj(clx,R_0,d_omega,omega_m,n,'CL');   % Odnormovani struktury II s prvnim pricnym C
subplot(2,1,2);
Title(['Schma filtru \pi po odnormovn pro Ro = ',int2str(R_0),' \Omega']);
Schema(LCP,R_0,R_0*r2p,n,'LP');   % Vykresleni schema zapojeni prickove struktury s prvni LC paralelne

% Kaskadni synteza s OZ
disp(' ');
disp('******************************************');
disp('* Kaskadni synteza aktivniho filtru s OZ *');
disp('******************************************');
disp('* Volby :  1 - Ano                       *');
disp('*          2 - Ne                        *');
disp('******************************************');
synteza = input('Chcete ji provest ? : ');
switch synteza
case 1  
    Aktivni(Hc_p);
case 2

end
disp(' ');
disp('Konec syntezy filtru :o)');
disp('Autor : David Hradeck, 2003');