function [Hnew] = Ftransf(Hin,dW,Wm)
% Zpetna kmitoctova transformace, fce vytvori novou prenosovou fci H(p) PP z H(s) NDP

[Hin_ci,Hin_jm] = tfdata(Hin,'v');  % Dostanu z transformovane fce zpet vektory citatele a jmenovatele
P = tf('p');
spp_ci = P^2 + Wm^2;    % Transformace PP podle 7.32
spp_jm = dW*P;
spp = spp_ci/spp_jm;    
Hnew_ci = 0;
Hnew_jm = 0;
for i=length(Hin_ci):-1:1   % Dosazeni do H(s)
    Hnew_ci = Hnew_ci + Hin_ci(length(Hin_ci)-i+1) * spp^(i-1);
end
for i=length(Hin_jm):-1:1
    Hnew_jm = Hnew_jm + Hin_jm(length(Hin_jm)-i+1) * spp^(i-1);
end
Hnew = Hnew_ci/Hnew_jm;
[Hn_ci,Hn_jm] = tfdata(Hnew,'v');
while Hn_jm(1) == 0 % Kdyz bude prvni nula ve vektoru, tak ji odstranim
      Hn_jm = Hn_jm(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
while Hn_ci(1) == 0 % Kdyz bude prvni nula ve vektoru, tak ji odstranim
      Hn_ci = Hn_ci(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
if Hn_jm(1) > 1
    rad = floor(log10(Hn_jm(1))); % Nejnizsi rad by mel byt na prvni pozici jmenovatele, viz H(s)
    Hn_ci = Hn_ci/10^rad;   % Odstraneni vysokych radu z funkce
    Hn_jm = Hn_jm/10^rad;
    koef = Hn_jm(1);
    Hn_ci = Hn_ci/koef;   % Nastaveni prvniho koeficientu jmenovatele na 1, tj. vykraceni jeho puvodni hodnotou
    Hn_jm = Hn_jm/koef;
end
N_ci = length(Hn_ci);
N_jm = length(Hn_jm);
if N_ci <= N_jm  % Snizeni stupne polynomu fce H(p), vykraceni p
    while Hn_jm(length(Hn_jm)) == 0 % Kdyz bude posledni nula ve vektoru, tak ji odstranim
      Hn_jm = Hn_jm(1:length(Hn_jm)-1); % Vektor pak bude kratsi od konce, snizim tak stupen polynomu
    end
    Hn_ci = Hn_ci(1:N_ci-(N_jm-length(Hn_jm)));
end
Hnew_ci = 0;
Hnew_jm = 0;
for i=length(Hn_ci):-1:1    % Upravenou fci opet prevedu na transformovany tvar H(p)
    Hnew_ci = Hnew_ci + Hn_ci(length(Hn_ci)-i+1) * P^(i-1);
end
for i=length(Hn_jm):-1:1
    Hnew_jm = Hnew_jm + Hn_jm(length(Hn_jm)-i+1) * P^(i-1);
end
Hnew = Hnew_ci/Hnew_jm;