% ******Inverzni Cebysevova aproximace******
% ******David Hradecky, 2003******
close all	% Zavreni oken s grafy (figure)
disp('Inverzni Cebysevova aproximace');
n = ceil(log(1/k1+sqrt(1/k1^2-1))/log(1/k+sqrt(1/k^2-1)));    % Stupen filtru, zaokrouhleno nahoru na cele cislo, 6.42
disp('Stupen filtru n :');
disp('=================');
n
% Prepocet parametru NDP na n cele
disp(' ');
disp('------------------------------------------------');
disp('Jake parametry NDP chcete prepocitat na n cele ?');
disp('------------------------------------------------');
disp('Volby :  1 - nove k1, as');
disp('         2 - nove k, OMEGAs');
nove = input('Vyberte : ');
disp(' ');
if nove == 1
   OMEGASn = OMEGAS;
   kn = k;
   k1 = 1/cosh(n*acosh(1/kn));  % Novy odstup modulu prenosu
   as = 10*log10(1+epsilon^2/k1^2);    % Novy utlum v nepropustnem pasmu, 6.43
else
   kn = 1/cosh((1/n)*acosh(1/k1));         % Novy pomer meznich kmitoctu
   OMEGASn = 1/kn;                         % Novy hranickni kmitocet nepropustneho pasma, 6.44
end
disp('Hranicni kmitocet nepropustneho pasma :');
OMEGASn
disp('Utlum v nepropustnem pasmu :');
as
% Parametry standardniho tolerancniho schematu NDP
H_ap = 1/sqrt(1+epsilon^2);
H_as = 1/sqrt(1+epsilon^2/k1^2);
plot([0,OMEGAP,OMEGAP],[H_ap,H_ap,0],'b-',[OMEGASn,OMEGASn,OMEGASn+1],[1,H_as,H_as],'r-');
Title('Standardn tolerann schma NDP');
Xlabel('\Omega');
Ylabel('|H(j\Omega)|');
pause;
% Vypocet pomocnych parametru, hlavni a vedlejsi poloosa elipsy podle 6.55
a = (1/2)*((sqrt(1+epsilon^2/k1^2)+epsilon/k1)^(1/n)-(sqrt(1+epsilon^2/k1^2)-epsilon/k1)^(1/n));
b = (1/2)*((sqrt(1+epsilon^2/k1^2)+epsilon/k1)^(1/n)+(sqrt(1+epsilon^2/k1^2)-epsilon/k1)^(1/n));

% Urceni polu prenosove fce H(s)
for i = 1:1:n
    s(i) = (1/kn)*(-a*sin((2*i-1)*pi/(2*n))+j*b*cos((2*i-1)*pi/(2*n)))/(a^2*(sin((2*i-1)*pi/(2*n)))^2+b^2*(cos((2*i-1)*pi/(2*n)))^2);  % Jen z leve poloroviny podle 6.84
    if abs(imag(s(i))) <= 0.00001   % Predpokladam jen zapornou imag. cast polu (stabilita)
        s(i) = real(s(i))+0*j;  % Nastaveni nuly imag. pri polu na realne ose a tak Matlabem vypoctene hodne male zbytecne hodnote
    end;
end
% Zobrazeni polu v komplexni rovine
S = zeros(2*n,1); % Pomocny vektor pro vykresleni spojnic polu s nulou
for i = 2:2:2*n
    S(i-1) = s(i/2);
end
plot([-a,a],[0,0],'k-',[0,0],[-b,b],'k-',real(S),imag(S),'c:',real(s),imag(s),'r*');
%axis([-(a+1/(10*a)),a+1/(10*a),-(b+1/(10*b)),b+1/(10*b)]);
grid; % Mrizka
for i=1:1:n
    text(real(s(i)),imag(s(i))+0.08,num2str(s(i),4),'FontSize',8);  % Zobrazeni hodnot polu
end
Title('Hledan poly penosov funkce, s = \Sigma + j\Omega');
Xlabel('Real[s] = \Sigma');
Ylabel('Imag[s] = j\Omega');
pause;
% Vypocet prenosove funkce H(s) podle 6.86, 6.88 a charakteristicke fce Fi(s) podle 6.87, 6.89
alfa = real(s);
beta = imag(s);
Fi_jm = 1;
if mod(n,2) == 1         % Je-li stupen aproximace n lichy
    m = (n-1)/2;
    H_jm = [1,1/(a*kn)];        % Repezentuje (s+1/(a*k)) jmenovatele
    H0 = n*k1/(epsilon*kn);
    G = (-1)^m*kn/(n*k1); % Nasobna konstanta charakteristicke fce upraveno pro 6.89
else                     % Je-li n sudy
    m = n/2;
    H_jm = 1;
    H0 = 1/sqrt(1+(epsilon/k1)^2);
    G = (-1)^m/k1;  % Nasobna konstanta charakteristicke fce upraveno pro 6.87
end
% Vypocet koeficientu polynomu ve jmenovateli prenosove fce
% Vypocet maxima aproximujici funkce v propustnem pasmu
H_ci = H0;
for i = 1:1:m
    Hp = [1,-2*alfa(i),(alfa(i)^2+beta(i)^2)];    % Zakladni polynom jmenovatele, vztah 6.86
    H_jm = conv(H_jm,Hp);           % Soucin polynomu H_jm*Hp jmenovatele pro n sude a liche
    OMEGA_0(i) = 1/(kn*cos((2*i-1)*pi/(2*n))); % Nulove body aproximujici funkce v nepropustnem pasmu, 6.85
    Hp = [1,0,OMEGA_0(i)^2];  % Zakladni polynom citatele, vztah 6.86
    H_ci = conv(H_ci,Hp);     % Soucin polynomu H_ci*Hp jmenovatele pro n sude a liche
    Fip = [1,0,OMEGA_0(i)^2];       % Reprezentuje (s^2 + OMEGA_0i^2) z vypoctu char.fce 6.87
    Fi_jm = conv(Fi_jm,Fip);        % Jmenovatel charakteristicke fce
end
[H,w] = freqs(H_ci,H_jm);             % Automaticky vypocet hodnot prenosove fce H(s) pro nekolik omega podle 6.86,6.88
Hinc = tf(H_ci,H_jm);                 % Vysledna prenosova funkce H(s) ve tvaru funkce
disp('Nulove body prenosove fce :');
OMEGA_0
% Graf modulove charakteristiky + tolerancni sch. NDP
subplot(2,1,1);
plot(w,abs(H),'b-',[0,OMEGAP,OMEGAP],[H_ap,H_ap,0],'b:',[OMEGASn,OMEGASn,OMEGASn+1],[1,H_as,H_as],'r:');
axis([0,ceil(OMEGASn)+1,0,1]); % xmin,xmax,ymin,ymax
text(ceil((OMEGAP+(OMEGASn-OMEGAP)/2)*10)/10,0.8,['n = ',int2str(n)]); 
Title('Izoextremln charakteristika modulu penosu NDP (Inverzn Cebysev)');
Xlabel('\Omega');
Ylabel('|H(j\Omega)|');
epsilon % vypis zakladnich hodnot
H0
disp('Prenosova fce H(s) NDP :');
disp('========================');
Hinc
% Dopocitani charakteristicke fce Fi
Fi_ci = [epsilon*G,zeros(1,n)];   % Citatel charakteristicke fce
Finc = tf(Fi_ci,Fi_jm);   % Vysledna charakteristicka fce Fi(s) ve tvaru funkce
disp('Charakteristicka funkce Fi(s) :');
disp('===============================');
Finc
%[F,Wf] = freqs(Fi_ci,Fi_jm);
%subplot(2,1,2);
%plot(Wf,abs(F),'b-'); % Ukazka prubehu char. fce
%axis([0,4,0,ceil(max(F))]);
%pause
% Vypocet skutecneho skupinoveho zpozdeni Tau
[d_G_ci,d_G_jm] = polyder(H_jm,H_ci); % derivovany podil dvou polynomu G(s)=H_jm/H_ci
Tci = conv(d_G_ci,H_ci);    % d_G_ci*H_ci
Tjm = conv(d_G_jm,H_jm);    % d_G_jm*H_jm
[Tau,W] = freqs(Tci,Tjm);   % automaticke vycisleni zlomku dG(s)/G(s) pro nejake kmitocty
Tau = abs(real(Tau));    % Vypoctene skutecne skupinove zpozdeni vychazejici z definice 5.29
subplot(2,1,2);
plot(W,Tau,'b-');
axis([0,ceil(OMEGASn)+1,0,ceil(max(Tau))]); % xmin,xmax,ymin,ymax
text(ceil((OMEGAP+(OMEGASn-OMEGAP)/2)*10)/10,n-0.5,['n = ',int2str(n)]); 
Title('Charakteristika skupinovho zpodn NDP (Inverzn Cebysev)');
Xlabel('\Omega');
Ylabel('\tau(\Omega)');
pause;
CLF;
% Fazova charakteristika
faze = angle(H);
subplot(2,1,1);
plot(w,(faze),'b-');
axis([0,ceil(OMEGASn)+1,-4,4]);
Xlabel('\Omega');
Ylabel('Faze');
Title('Fzov charakteristika NDP');
pause;
close all	% Zavreni oken s grafy (figure)

% ***** Realizace, urceni soucastek *****
% NDP
disp('---------------------------------------------');
disp('Pro jake Fi chcete sestavit kaskadni matici ?');
disp('---------------------------------------------');
disp('Volby :  1 - pro +Fi');
disp('         2 - pro -Fi');
PolFi = input('Zvolte polaritu : ');
disp(' ');
if PolFi == 1
   PolFi = '+';
else
   PolFi = '-';
end

%[a11,a12,a21,a22] = SestavM(Hin,Fin,Ho,Polarita)
[a11,a12,a21,a22]=SestavM(Hinc,Finc,H0,PolFi);    % Sestaveni parametru kaskadni matice A pro +-Fi
disp(['Parametry kaskadni matice pro ',PolFi,'Fi :']);
disp('-----------------------------------');
a11
a12
a21
a22
%[Soucastky,Zacatek] = Stipacka(a11,a12,a21,a22,Stupen,NulBod,Polarita)
[lcx,Prvni] = Stipacka(a11,a12,a21,a22,n,OMEGA_0,PolFi);    % Vypcet hodnot soucastek NDP
%Prvni
%lcx'

CLF;    % Vymaze grafy
Title('Schma filtru NDP');
Schema(lcx,1,1,n,Prvni);   % Vykresleni schema zapojeni prickove struktury
pause;

% Kmitoctove odnormovani
% Vypocet prenosove funkce PP H(p)
Hinc_p = Ftransf(Hinc,d_omega,omega_m); % Transformace H(s) na H(p)
disp('Prenosova fce H(p) PP :');
disp('=======================');
Hinc_p
[Hincp_ci,Hincp_jm] = tfdata(Hinc_p,'v');  % Dostanu z transformovane fce zpet vektory citatele a jmenovatele
%[Hp,wp] = freqs(Hincp_ci,Hincp_jm);      % Automaticky vypocet hodnot prenosove fce H(p)
%f = wp/(2*pi);
sf = ceil(f_s + (fs - f_s)/2);
fpoc = f_s - ceil(sf/5);
if fpoc < 0
   fpoc = 0;
end
fkon = fs + ceil(sf/5);
i = 1;
for f = fpoc+1:fkon/500:fkon    % Vhodne jen pro kmitocty blizke "nule", radove az kHz
    wp(i) = f*2*pi;
    fh(i) = f;
    i = i + 1;
end
Hp = freqs(Hincp_ci,Hincp_jm,wp);   % Vypocet pro vice omega nez to pocita automaticky, protoze je potreba vice hodnot pro H(p) vyssich radu

% Graf modulove charakteristiky H(p)+ tolerancni sch. PP
subplot(2,1,1);
plot(fh,abs(Hp),'b-',[0,f_s,f_s],[H_as,H_as,1],'r:',[f_p,f_p,fp,fp],[0,H_ap,H_ap,0],'b:',[fs,fs,fkon],[1,H_as,H_as],'r:');
axis([fpoc,fkon,0,1]); % xmin,xmax,ymin,ymax
Title('Izoextremln charakteristika modulu penosu PP (Inverzn Cebysev)');
Xlabel('f [Hz]');
Ylabel('|H(p)|');
% Vypocet skutecneho skupinoveho zpozdeni Tau
[d_G_ci,d_G_jm] = polyder(Hincp_jm,Hincp_ci); % derivovany podil dvou polynomu G(p)=Hbp_jm/Hbp_ci
Tci = conv(d_G_ci,Hincp_ci);    % d_G_ci*H_ci
Tjm = conv(d_G_jm,Hincp_jm);    % d_G_jm*H_jm
%[Tau,W] = freqs(Tci,Tjm);   % automaticke vycisleni zlomku dG(p)/G(p) pro nejake kmitocty
%ft = W/(2*pi);
Tau = freqs(Tci,Tjm,wp);   % Vypocet pro vice omega nez to pocita automaticky, pro vyssi rozliseni
Tau = abs(real(Tau));    % Vypoctene skutecne skupinove zpozdeni vychazejici z definice 5.29
subplot(2,1,2);
plot(fh,Tau,'b-');
axis([fpoc,fkon,0,max(Tau)+max(Tau)/10]); % xmin,xmax,ymin,ymax
Title('Charakteristika skupinovho zpodn PP (Inverzn Cebysev)');
Xlabel('f [Hz]');
Ylabel('\tau [s]');
% Vypocet charakteristicke fce Fi(p) PP
Finc_p = Ftransf(Finc,d_omega,omega_m);
%disp('Charakteristicka funkce Fi(p) PP :');
%disp('==================================');
%Finc_p % Jen ji nevypisuji
pause;
close all	% Zavreni oken s grafy (figure)

% Odnormovani
disp('-----------------------------------');
disp('* Zvolte impedancni uroven obvodu *');
disp('-----------------------------------');
R_0 = input(' Ro = '); % Impedancni uroven
%[LC] = Odnormuj(Soucastky,R0,dW,Wm,Stupen,Struktura)
[LC] = Odnormuj(lcx,R_0,d_omega,omega_m,n,Prvni); % Odnormovani prvku NDP na PP podle prvniho prvku ve strukture NDP
%LC' % Ve vektoru se stridaji stale L a C, prvni je vzdy L

CLF;    % Vymaze grafy
Title(['Schma filtru PP po odnormovn pro Ro = ',int2str(R_0),' \Omega']);
Schema(LC,R_0,R_0,n,[Prvni,'N']);   % Vykresleni schema zapojeni prickove struktury

disp(' ');
disp('Konec syntezy filtru :o)');
disp('Autor : David Hradeck, 2003');