function [LCnew] = Odnormuj(Soucastky,R0,dW,Wm,Stupen,Struktura)
% Odnormovani a prepocet soucastek PP podle tab. 7.4

% Pro Butterworthovu a Cebysevovu aproximaci
if Struktura == 'LC'    % Struktura zacina podelnym (vodorovnym) induktorem
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice, transformace L na seriove zap. L=C
           LCnew(i*2-1) = R0*Soucastky(i)/dW;    % L
           LCnew(i*2) = dW/(R0*Soucastky(i)*Wm*Wm);  % C
        else    % Suda pozice, transformace C na paralelni zap. L//C
           LCnew(i*2-1) = dW*R0/(Wm*Wm*Soucastky(i));    % L
           LCnew(i*2) = Soucastky(i)/(R0*dW);  % C
        end
    end    
end
if Struktura == 'CL'    % Struktura zacina pricnym kapacitorem
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice, transformace C na paralelni zap. L//C
           LCnew(i*2-1) = dW*R0/(Wm*Wm*Soucastky(i));    % L
           LCnew(i*2) = Soucastky(i)/(R0*dW);  % C
        else    % Suda pozice, transformace L na seriove zap. L=C
           LCnew(i*2-1) = R0*Soucastky(i)/dW;    % L
           LCnew(i*2) = dW/(R0*Soucastky(i)*Wm*Wm);  % C
        end
    end    
end
% Pro Inverzni Cebysevovu aproximaci
Rozmer = length(Soucastky);
if Struktura == 'L'    % Struktura zacina podelnym (vodorovnym) induktorem
    ii = 1;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice, transformace L na seriove zap. L=C
           LCnew(i*3-2) = R0*Soucastky(ii)/dW;    % L
           LCnew(i*3-1) = dW/(R0*Soucastky(ii)*Wm*Wm);  % C
           ii = ii + 1;
        else    % Suda pozice, transformace serioveho zap. L=C
           % transformace L na seriove zap. L=C
           LCnew(i*3-3) = R0*Soucastky(ii)/dW;    % L
           LCnew(i*3-2) = dW/(R0*Soucastky(ii)*Wm*Wm);  % C 
           ii = ii + 1;
           % transformace C na paralelni zap. L//C
           LCnew(i*3-1) = dW*R0/(Wm*Wm*Soucastky(ii));    % L
           LCnew(i*3) = Soucastky(ii)/(R0*dW);  % C
           ii = ii + 1;
        end
    end
    if Rozmer >= ii % Zbyvajici prvek, tady L
           % transformace L na seriove zap. L=C
           Roz = length(LCnew);
           if Soucastky(ii) ~= 0    % Pro pripad, kdyby prvek navic byl nulovy
              LCnew(Roz+1) = R0*Soucastky(ii)/dW;    % L
              LCnew(Roz+2) = dW/(R0*Soucastky(ii)*Wm*Wm);  % C
           end
    end
end
if Struktura == 'C'    % Struktura zacina pricnym kapacitorem
    ii = 1;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice, transformace C na paralelni zap. L//C
           LCnew(i*3-2) = dW*R0/(Wm*Wm*Soucastky(ii));    % L
           LCnew(i*3-1) = Soucastky(ii)/(R0*dW);  % C
           ii = ii + 1;
        else    % Suda pozice, transformace paralelniho zap. L//C
           % transformace C na paralelni zap. L//C
           LCnew(i*3-3) = dW*R0/(Wm*Wm*Soucastky(ii));    % L
           LCnew(i*3-2) = Soucastky(ii)/(R0*dW);  % C
           ii = ii + 1;
           % transformace L na seriove zap. L=C
           LCnew(i*3-1) = R0*Soucastky(ii)/dW;    % L
           LCnew(i*3) = dW/(R0*Soucastky(ii)*Wm*Wm);  % C
           ii = ii + 1;
        end
    end
    if Rozmer >= ii % Zbyvajici prvek, tady C
           % transformace C na paralelni zap. L//C
           Roz = length(LCnew);
           if Soucastky(ii) ~= 0    % Pro pripad, kdyby prvek navic byl nulovy
              LCnew(Roz+1) = dW*R0/(Wm*Wm*Soucastky(ii));    % L
              LCnew(Roz+2) = Soucastky(ii)/(R0*dW);  % C
           end
    end
end