function [] = Schema(Soucastky,Zacatek,Zakonceni,Stupen,Struktura)
% Vykresli schema zapojeni filtru v prickove strukture CL, LC, LS, LP, C, L, CN, LN
% Cx(Pozice,Oznaceni,Hodnota,Poloha)

if Struktura == 'LC'    % Struktura zacina podelnym (vodorovnym) induktorem NDP
    Ux(0,1);  % Zdroj
    Rx(0,1,1,Zacatek,'V','-'); % Vstupni odpor
    Px(0,0,'V','-');
    Licha = 1; Suda = 2;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice
           Lx(Licha,1,i,Soucastky(i),'V','-');    % Induktor  vodorovny
           Px(Licha,0,'V','-');   % Propojka
           Licha = Licha + 1;
        else    % Suda pozice
           Cx(Suda,1,i,Soucastky(i),'S','U');     % Kapacitor svisly
           Suda = Suda + 1;
        end
    end
    if mod(Stupen,2) ~= 1    % Sudy stupen
       Px(Licha,1,'V','-');   % Propojka
       Px(Licha,0,'V','-');
    end
    Rx(Suda,1,2,Zakonceni,'S','-');   % Zakoncovaci odpor
    axis([-1,Suda+1,-1,2]);
end
if Struktura == 'CL'    % Struktura zacina pricnym kapacitorem NDP
    Ux(0,1);  % Zdroj
    Rx(0,1,1,Zacatek,'V','-'); % Vstupni odpor
    Px(0,0,'V','-');
    Licha = 1; Suda = 1;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice
           Cx(Licha,1,i,Soucastky(i),'S','U');    % Kapacitor svisly
           Licha = Licha + 1;
        else    % Suda pozice
           Lx(Suda,1,i,Soucastky(i),'V','-');     % Induktor vodorovny
           Px(Suda,0,'V','-');   % Propojka
           Suda = Suda + 1;
        end
    end
    if mod(Stupen,2) == 1    % Lichy stupen
       Px(Suda,1,'V','-');   % Propojka
       Px(Suda,0,'V','-');
    end
    Rx(Licha,1,2,Zakonceni,'S','-');   % Zakoncovaci odpor
    axis([-1,Licha+1,-1,2]);
end
if Struktura == 'LS'    % Struktura zacina podelnym seriovym zap. LC PP
    Ux(0,1);  % Zdroj
    Rx(0,1,1,Zacatek,'V','-'); % Vstupni odpor
    Px(0,0,'V','-');
    Poz = 1;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice
           Lx(Poz,1,i,Soucastky(i*2-1),'V','-');    % Induktor  vodorovny
           Px(Poz,0,'V','-');   % Propojka
           Poz = Poz + 1;
           Cx(Poz,1,i,Soucastky(i*2),'V','-');        % Kapacitor vodorovny
           Px(Poz,0,'V','-');
           Poz = Poz + 1;
        else    % Suda pozice
           Lx(Poz,1,i,Soucastky(i*2-1),'S','U');   % Induktor svisly 
           Px(Poz,1,'V','-');   % Propojka
           Px(Poz,0,'V','-');   % Propojka
           Poz = Poz + 1;
           Cx(Poz,1,i,Soucastky(i*2),'S','U');     % Kapacitor svisly
        end
    end
    if mod(Stupen,2) ~= 1    % Sudy stupen
       Px(Poz,1,'V','-');   % Propojka
       Px(Poz,0,'V','-');
       Poz = Poz + 1;
    end
    Rx(Poz,1,2,Zakonceni,'S','-');   % Zakoncovaci odpor
    axis([-1,Poz+1,-1,2]);
end
if Struktura == 'LP'    % Struktura zacina pricnym paralelnim zap. LC PP
    Ux(0,1);  % Zdroj
    Rx(0,1,1,Zacatek,'V','-'); % Vstupni odpor
    Px(0,0,'V','-');
    Poz = 1;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice
           Lx(Poz,1,i,Soucastky(i*2-1),'S','U');   % Induktor svisly 
           Px(Poz,1,'V','-');   % Propojka
           Px(Poz,0,'V','-');   % Propojka
           Poz = Poz + 1;
           Cx(Poz,1,i,Soucastky(i*2),'S','U');     % Kapacitor svisly
        else    % Suda pozice
           Lx(Poz,1,i,Soucastky(i*2-1),'V','-');    % Induktor  vodorovny
           Px(Poz,0,'V','-');   % Propojka
           Poz = Poz + 1;
           Cx(Poz,1,i,Soucastky(i*2),'V','-');        % Kapacitor vodorovny
           Px(Poz,0,'V','-');
           Poz = Poz + 1;
        end
    end
    if mod(Stupen,2) == 1    % Lichy stupen
       Px(Poz,1,'V','-');   % Propojka
       Px(Poz,0,'V','-');
       Poz = Poz + 1;
    end
    Rx(Poz,1,2,Zakonceni,'S','-');   % Zakoncovaci odpor
    axis([-1,Poz+1,-1,2]);
end

% Pro Inverzni Cebysevovu aproximaci
Rozmer = length(Soucastky);
if Struktura == 'L'    % Struktura zacina podelnym (vodorovnym) induktorem NDP
    Px(0,0,'V','-');
    Px(0,1,'S','-');
    Ux(0,2);  % Zdroj
    Rx(0,2,1,Zacatek,'V','-'); % Vstupni odpor
    ii = 1;
    Licha = 1; Suda = 2;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice
           if Licha > 1
               Lx(Licha,2,i,Soucastky(ii),'V','U1');    % Induktor  vodorovny
               Px(Licha,0,'V','U1');   % Propojka
           else
               Lx(Licha,2,i,Soucastky(ii),'V','-');    % Induktor  vodorovny
               Px(Licha,0,'V','-');   % Propojka
           end
           ii = ii + 1;
           Licha = Licha + 1;
        else    % Suda pozice
           Lx(Suda,2,i,Soucastky(ii),'S','-');    % Induktor svisly
           ii = ii + 1;
           Cx(Suda,1,i,Soucastky(ii),'S','-');     % Kapacitor svisly
           ii = ii + 1;
           Suda = Suda + 1;
        end
    end
    if Rozmer >= ii % Zbyvajici prvek, tady L
           if Soucastky(ii) ~= 0    % Pro pripad, kdyby prvek navic byl nulovy
              Lx(Licha,2,i,Soucastky(ii),'V','U1');    % Induktor  vodorovny
              Px(Licha,0,'V','U1');   % Propojka
              Licha = Licha + 1;
           end
    end
    if Suda ~= Licha    % Uprava konce pro ruzne rozlozeni soucastek
       Px(Licha,2,'V','-');   % Propojka navic
       Px(Licha,0,'V','-');
    end
    Px(Suda,1,'S','-');
    Rx(Suda,2,2,Zakonceni,'S','-');   % Zakoncovaci odpor
    axis([-1,Suda+1,-1,3]);
end
if Struktura == 'C'    % Struktura zacina pricnym kapacitorem NDP
    Px(0,0,'V','-');
    Ux(0,1);  % Zdroj
    Rx(0,1,1,Zacatek,'V','-'); % Vstupni odpor
    Licha = 1; Suda = 1;
    ii = 1;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice
           Cx(Licha,1,i,Soucastky(ii),'S','U');    % Kapacitor svisly
           ii = ii + 1;
           Licha = Licha + 1;
        else    % Suda pozice
           Cx(Suda,2,i,Soucastky(ii),'V','-');    % Kapacitor vodorovny a // L
           ii = ii + 1;
           if Suda > 1
               Px(Suda,2,'S','U');   % Propojka s uzly
           else
               Px(Suda,2,'S','-');   % Propojka
           end
           Px(Suda+1,2,'S','-');   % Propojka
           Lx(Suda,1,i,Soucastky(ii),'V','-');     % Induktor vodorovny
           ii = ii + 1;
           Px(Suda,0,'V','-');   % Propojka
           Suda = Suda + 1;
        end
    end
    if Rozmer >= ii % Zbyvajici prvek, tady C
           if Soucastky(ii) ~= 0    % Pro pripad, kdyby prvek navic byl nulovy
              Cx(Licha,1,i+1,Soucastky(ii),'S','U');    % Kapacitor svisly
              Licha = Licha + 1;
           end
    end
    if Suda ~= Licha    % Uprava konce pro ruzne rozlozeni soucastek
       Px(Suda,1,'V','-');   % Propojka navic
       Px(Suda,0,'V','-');
    end
    Rx(Licha,1,2,Zakonceni,'S','-');   % Zakoncovaci odpor
    axis([-1,Licha+1,-1,3]);
end

if Struktura == 'LN'    % Struktura zacina podelnym (vodorovnym) seriovym zap. L=C, PP
    Px(0,0,'V','-');
    Px(0,1,'S','-');
    Ux(0,2);  % Zdroj
    Px(0,3,'S','-');
    Rx(0,3,1,Zacatek,'V','-'); % Vstupni odpor
    ii = 1;
    Poz = 1;
    Ozn = 1;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice L=C
           Lx(Poz,3,Ozn,Soucastky(ii),'V','-');    % Induktor  vodorovny
           Px(Poz,0,'V','-');   % Propojka
           ii = ii + 1;
           Poz = Poz + 1;
           Cx(Poz,3,Ozn,Soucastky(ii),'V','-');    % Induktor  vodorovny
           Px(Poz,0,'V','-');   % Propojka
           ii = ii + 1;
           Poz = Poz + 1;
           Ozn = Ozn + 1;
        else    % Suda pozice, L=C a L//C
           % Seriove L=C
           Lx(Poz,3,Ozn,Soucastky(ii),'S','U1');    % Induktor svisly
           ii = ii + 1;
           Cx(Poz,2,Ozn,Soucastky(ii),'S','-');     % Kapacitor svisly
           ii = ii + 1;
           Ozn = Ozn + 1;
           % Paralelni L//C
           Lx(Poz,1,Ozn,Soucastky(ii),'S','U1');    % Induktor svisly
           Px(Poz,1,'V','-');   % Propojka
           ii = ii + 1;
           Cx(Poz+1,1,Ozn,Soucastky(ii),'S','-');     % Kapacitor svisly
           Px(Poz,0,'V','U');   % Propojka
           ii = ii + 1;
           Ozn = Ozn + 1;
           %Poz = Poz + 1;
        end
    end
    if Rozmer >= ii % Zbyvajici prvek, tady L=C
           if Soucastky(ii) ~= 0    % Pro pripad, kdyby prvek navic byl nulovy
              Lx(Poz,3,Ozn,Soucastky(ii),'V','-');    % Induktor vodorovny
              Px(Poz,0,'V','-');   % Propojka
              Poz = Poz + 1;
              ii = ii + 1;
              Cx(Poz,3,Ozn,Soucastky(ii),'V','-');    % Kapacitor vodorovny
              Px(Poz,0,'V','-');   % Propojka
              Poz = Poz + 1;
           end
    end
    if mod(Ozn,2) == 0    % Suda pozice, uprava konce pro ruzne rozlozeni soucastek
       Px(Poz,3,'V','-');   % Propojka navic
       Px(Poz,0,'V','-');
       Poz = Poz + 1;
    end
    Px(Poz,1,'S','-');
    Px(Poz,3,'S','-');
    Rx(Poz,2,2,Zakonceni,'S','-');   % Zakoncovaci odpor
    axis([-1,Poz+1,-1,4]);
end
if Struktura == 'CN'    % Struktura zacina pricnym paralelnim zap. L//C, PP
    Px(0,0,'V','-');
    Ux(0,1);  % Zdroj
    Rx(0,1,1,Zacatek,'V','-'); % Vstupni odpor
    Licha = 1; Suda = 1;
    ii = 1;
    Poz = 1;
    Ozn = 1;
    for i=1:1:Stupen
        if mod(i,2) == 1    % Licha pozice L//C
           Lx(Poz,1,Ozn,Soucastky(ii),'S','U');    % Induktor svisly
           ii = ii + 1;
           Px(Poz,1,'V','-');   % Propojka
           Px(Poz,0,'V','-');   % Propojka
           Poz = Poz + 1;
           Cx(Poz,1,Ozn,Soucastky(ii),'S','U');    % Kapacitor svisly
           ii = ii + 1;
           Ozn = Ozn + 1;
        else    % Suda pozice
           % Paralelni zap. L//C
           Lx(Poz,1,Ozn,Soucastky(ii),'V','-');    % Induktor  vodorovny
           ii = ii + 1;
           Px(Poz,0,'V','-');   % Propojka
           Cx(Poz,2,Ozn,Soucastky(ii),'V','U');        % Kapacitor vodorovny
           ii = ii + 1;
           Ozn = Ozn + 1;
           Px(Poz,2,'S','-');
           Px(Poz+1,2,'S','-');
           % Seriove zap. L=C
           Lx(Poz,3,Ozn,Soucastky(ii),'V','-');    % Induktor  vodorovny
           ii = ii + 1;
           Px(Poz,3,'S','-');
           Cx(Poz+1,3,Ozn,Soucastky(ii),'S','-');    % Kapacitor svisly
           ii = ii + 1;
           Ozn = Ozn + 1;
           Poz = Poz + 1;
        end
    end
    if Rozmer >= ii % Zbyvajici prvek, tady L//C
           if Soucastky(ii) ~= 0    % Pro pripad, kdyby prvek navic byl nulovy
              Lx(Poz,1,Ozn,Soucastky(ii),'S','U');    % Induktor svisly
              Px(Poz,1,'V','-');   % Propojka
              Px(Poz,0,'V','-');   % Propojka
              Poz = Poz + 1;
              ii = ii + 1;
              Cx(Poz,1,Ozn,Soucastky(ii),'S','U');    % Kapacitor svisly
           end
    end
    if mod(Poz,2) == 0    % Suda pozice, uprava konce pro ruzne rozlozeni soucastek
       Px(Poz,1,'V','-');   % Propojka navic
       Px(Poz,0,'V','-');
       Poz = Poz + 1;
    end
    Rx(Poz,1,2,Zakonceni,'S','-');   % Zakoncovaci odpor
    axis([-1,Poz+1,-1,4]);
end