function [a11,a12,a21,a22] = SestavM(Hin,Fin,Ho,Polarita)
% Sestaveni kaskadni matice z H(s) a Fi(s) pro R1 = R2 = 1 podle 5.48

Hin = Hin/Ho;   % Uprava fci na spolecny jmenovatel b(s)
Gin = 1/Hin;
Gin = Gin/Ho;
[Gin_ci,Gin_jm] = tfdata(Gin,'v');  % Dostanu z transformovane fce zpet vektory citatele a jmenovatele
[Fin_ci,Fin_jm] = tfdata(Fin,'v');
   Su_Gin_ci = Gin_ci;
   Li_Gin_ci = Gin_ci;
   Su_Fin_ci = Fin_ci;
   Li_Fin_ci = Fin_ci;
   rozmer = length(Gin_ci);
   if mod(rozmer,2) == 0    % Sudy rozmer vektoru => polynom zacina lichou mocninou
       moc = 1;
   else % Polynom zacina sudou mocninou
       moc = 0;
   end
   for i = 1:1:rozmer 
      if mod(i,2) == moc  % Sude mocniny pouze
         Su_Gin_ci(i) = 0;
      else  % Liche mocniny pouze
         Li_Gin_ci(i) = 0;
      end
   end
   rozmer = length(Fin_ci);
   if mod(rozmer,2) == 0    % Sudy rozmer vektoru => polynom zacina lichou mocninou
       moc = 1;
   else % Polynom zacina sudou mocninou
       moc = 0;
   end
   for i = 1:1:rozmer 
      if mod(i,2) == moc  % Sude mocniny pouze
         Su_Fin_ci(i) = 0;
      else  % Liche mocniny pouze
         Li_Fin_ci(i) = 0;
      end
   end
   if Polarita == '+' % Pro +Fi
       % ! Predelat na transformovane scitani a odcitani, protoze vektory nemusi mit stejne rozmery
       a11 = Su_Gin_ci + Su_Fin_ci;
       a12 = Li_Gin_ci + Li_Fin_ci;
       a21 = Li_Gin_ci - Li_Fin_ci;
       a22 = Su_Gin_ci - Su_Fin_ci;
   end
   if Polarita == '-' % Pro -Fi
       a11 = Su_Gin_ci - Su_Fin_ci;
       a12 = Li_Gin_ci - Li_Fin_ci;
       a21 = Li_Gin_ci + Li_Fin_ci;
       a22 = Su_Gin_ci + Su_Fin_ci;
   end
while abs(a11(1)) < 1e-12 % Kdyz bude prvni "nula" ve vektoru, tak ji odstranim
      a11 = a11(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
while abs(a12(1)) < 1e-12 % Kdyz bude prvni "nula" ve vektoru, tak ji odstranim
      a12 = a12(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
while abs(a21(1)) < 1e-12 % Kdyz bude prvni "nula" ve vektoru, tak ji odstranim
      a21 = a21(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
while abs(a22(1)) < 1e-12 % Kdyz bude prvni "nula" ve vektoru, tak ji odstranim
      a22 = a22(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
a11 = tf(a11,Fin_jm);
a12 = tf(a12,Fin_jm);
a21 = tf(a21,Fin_jm);
a22 = tf(a22,Fin_jm);
