function [Soucastky,Zacatek] = Stipacka(a11,a12,a21,a22,Stupen,NulBod,Polarita)
% Odstepovani dilciho dvojbranu podle 7.18, 7.19 z vychozi kaskadni matice A v transformovanem tvaru
% Realizece ze vstupnich svorek

[a11_ci,a11_jm] = tfdata(a11,'v');
[a12_ci,a12_jm] = tfdata(a12,'v');
[a21_ci,a21_jm] = tfdata(a21,'v');
[a22_ci,a22_jm] = tfdata(a22,'v');
a11tf_ci = tf(a11_ci,[1]);   % Budu pocitat jen s citateli v transformovanem tvaru
a12tf_ci = tf(a12_ci,[1]);
a21tf_ci = tf(a21_ci,[1]);
a22tf_ci = tf(a22_ci,[1]);
while a11_ci(1) == 0 % Kdyz bude prvni nula ve vektoru, tak ji odstranim
      a11_ci = a11_ci(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
while a12_ci(1) == 0 % Kdyz bude prvni nula ve vektoru, tak ji odstranim
      a12_ci = a12_ci(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
while a21_ci(1) == 0 % Kdyz bude prvni nula ve vektoru, tak ji odstranim
      a21_ci = a21_ci(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
while a22_ci(1) == 0 % Kdyz bude prvni nula ve vektoru, tak ji odstranim
      a22_ci = a22_ci(1,2:end); % Vektor pak bude zacinat az od druhe pozice
end
Na11 = length(a11_ci);  % "Stupen" citatele a11
Na12 = length(a12_ci);  % "Stupen" citatele a12
Na21 = length(a21_ci);  % "Stupen" citatele a21
Na22 = length(a22_ci);  % "Stupen" citatele a22
Soucastky = 0;
Nb = length(NulBod); % Pocet nul. bodu
Ks = tf([1,0],[1]);   % Pomocna nasobna konstanta "s" pro vztahy 7.21
Zacatek = '-';
if mod(Stupen,2) == 1    % Je-li stupen filtru lichy
   if Na12 > Na21  % Zacneme odstepenim dilciho dvojbranu s podelnou L u dvojice parametru a11, a12
      %Na12
      Zacatek = 'L';            
   end
   if Na12 < Na21  % Zacneme odstepenim dilciho dvojbranu s pricnou C u dvojice parametru a21, a22
      %Na21
      Zacatek = 'C';
   end  
end
if mod(Stupen,2) == 0   % Je-li stupen filtru sudy
    if Na11 > Na22  % Zacneme odstepenim dilciho dvojbranu s podelnou L u dvojice parametru a11, a12
       %Na11
       Zacatek = 'L';            
    end
    if Na11 < Na22  % Zacneme odstepenim dilciho dvojbranu s pricnou C u dvojice parametru a21, a22
       %Na22
       Zacatek = 'C';
    end
    if Na11 == Na22  % Jsou-li stupne citatelu stejne, musime rozhodnout o tom, ktery prvek matice obsahuje +Fi
        if Polarita == '+' % Nejprve u a11,a12 odstepime dilci dvojbran podelnym L
            %disp('+');
            %Na11
            %Na22
            Zacatek = 'L';    
        end
        if Polarita == '-' % Nejprve u a21,a22 odstepime dilci dvojbran pricnym C
            %disp('-');
            %Na11
            %Na22
            Zacatek = 'C';            
        end
    end    
end
if Zacatek == 'L'
   ii = 1;
            for i = 1:1:Nb
                % Vypocet podelnych prvku podle 7.24
                L_ci = polyval(a11_ci,j*NulBod(i));
                L_jm = polyval(a21_ci,j*NulBod(i));
                Soucastky(ii) = L_ci/(j*NulBod(i)*L_jm);   % OK Podelny L
                % Nove parametry matice podle 7.19
                % a11
                a11tf_ci = a11tf_ci - (Soucastky(ii)*a21tf_ci*Ks); % Odstepeni podelneho L v tranformovanem tvaru
                a11_ci = tfdata(a11tf_ci,'v');   % Hned zpet na normalni vektor (koeficienty polynomu)
                axx_jm = poly([j*NulBod(i);-j*NulBod(i)]);  % Pomocny polynom, kterym budu delit, tj. kratit polynomem, ktrey ma za koren prave tento pol (n.b)
                a11_ci = deconv(a11_ci,axx_jm);  % Novy citatel a11 po odstepeni aktualniho polu (vykraceni)
                a11tf_ci = tf(a11_ci,[1]);  % Novy citatel a11 v transformovanem tvaru
                a11_jm = deconv(a11_jm,axx_jm);  % Novy jmenovatel a11 po odstepeni aktualniho polu
                % a12
                a12tf_ci = a12tf_ci - (Soucastky(ii)*a22tf_ci*Ks);
                a12_ci = tfdata(a12tf_ci,'v');
                a12_ci = deconv(a12_ci,axx_jm);  % Novy citatel a12 po odstepeni aktualniho polu (vykraceni)
                a12tf_ci = tf(a12_ci,[1]);  % Novy citatel a12 v transformovanem tvaru
                a12_jm = deconv(a12_jm,axx_jm);  % Novy jmenovatel a12 po odstepeni aktualniho polu
                ii = ii + 1;
                % Vypocet pricnych prvku L a C podle 7.25
                L_ci = polyval(a12_ci,j*NulBod(i));
                L_jm = polyval(a22_ci,j*NulBod(i));
                Soucastky(ii) = L_ci*(j*NulBod(i))/L_jm;    % OK Pricny L
                ii = ii + 1;
                Soucastky(ii) = 1/(NulBod(i)^2 * Soucastky(ii-1)); %  OK Pricny C
                % Nove parametry matice podle 7.18
                % a21
                a21tf_ci = a21tf_ci - ((1/Soucastky(ii-1))*a11tf_ci*Ks); % Odstepeni pricnych prvku
                a21_ci = tfdata(a21tf_ci,'v');
                a21_ci = deconv(a21_ci,axx_jm);  % Novy citatel a21 po odstepeni aktualniho polu (vykraceni)
                a21tf_ci = tf(a21_ci,[1]);  % Novy citatel a21 v transformovanem tvaru
                a21_jm = deconv(a21_jm,axx_jm);  % Novy jmenovatel a21 po odstepeni aktualniho polu
                % a22
                a22tf_ci = a22tf_ci - ((1/Soucastky(ii-1))*a12tf_ci*Ks);
                a22_ci = tfdata(a22tf_ci,'v');
                a22_ci = deconv(a22_ci,axx_jm);  % Novy citatel a22 po odstepeni aktualniho polu (vykraceni)
                a22tf_ci = tf(a22_ci,[1]);  % Novy citatel a22 v transformovanem tvaru
                a22_jm = deconv(a22_jm,axx_jm);  % Novy jmenovatel a22 po odstepeni aktualniho polu
                ii = ii + 1;
            end
            Soucastky(ii) = a12_ci(1); % Zbyly podelny L
            % Zapojeni tedy zacina podelny L 
end
if Zacatek == 'C'
    ii = 1;
            for i = 1:1:Nb
                % Vypocet pricnych prvku podle 7.22
                C_ci = polyval(a22_ci,j*NulBod(i));
                C_jm = polyval(a12_ci,j*NulBod(i));
                Soucastky(ii) = C_ci/(j*NulBod(i)*C_jm);   % Pricny C
                % Nove parametry matice podle 7.18
                % a21
                a21tf_ci = a21tf_ci - (Soucastky(ii)*a11tf_ci*Ks); % Odstepeni pricneho C v tranformovanem tvaru
                a21_ci = tfdata(a21tf_ci,'v');   % Hned zpet na normalni vektor (koeficienty polynomu)
                axx_jm = poly([j*NulBod(i);-j*NulBod(i)]);  % Pomocny polynom, kterym budu delit, tj. kratit polynomem, ktrey ma za koren prave tento pol (n.b)
                a21_ci = deconv(a21_ci,axx_jm);  % Novy citatel a21 po odstepeni aktualniho polu (vykraceni)
                a21tf_ci = tf(a21_ci,[1]);  % Novy citatel a21 v transformovanem tvaru
                a21_jm = deconv(a21_jm,axx_jm);  % Novy jmenovatel a11 po odstepeni aktualniho polu
                % a22
                a22tf_ci = a22tf_ci - (Soucastky(ii)*a12tf_ci*Ks);
                a22_ci = tfdata(a22tf_ci,'v');
                a22_ci = deconv(a22_ci,axx_jm);  % Novy citatel a22 po odstepeni aktualniho polu (vykraceni)
                a22tf_ci = tf(a22_ci,[1]);  % Novy citatel a22 v transformovanem tvaru
                a22_jm = deconv(a22_jm,axx_jm);  % Novy jmenovatel a22 po odstepeni aktualniho polu
                ii = ii + 1;
                % Vypocet podelynych prvku L // C podle 7.23
                C_ci = polyval(a21_ci,j*NulBod(i));
                C_jm = polyval(a11_ci,j*NulBod(i));
                Soucastky(ii) = C_ci*(j*NulBod(i))/C_jm;    % Podelny C
                ii = ii + 1;
                Soucastky(ii) = 1/(NulBod(i)^2 * Soucastky(ii-1)); %  Podelny L
                % Nove parametry matice podle 7.19
                % a11
                a11tf_ci = a11tf_ci - ((1/Soucastky(ii-1))*a21tf_ci*Ks); % Odstepeni pricnych prvku
                a11_ci = tfdata(a11tf_ci,'v');
                a11_ci = deconv(a11_ci,axx_jm);  % Novy citatel a11 po odstepeni aktualniho polu (vykraceni)
                a11tf_ci = tf(a11_ci,[1]);  % Novy citatel a11 v transformovanem tvaru
                a11_jm = deconv(a11_jm,axx_jm);  % Novy jmenovatel a11 po odstepeni aktualniho polu
                % a12
                a12tf_ci = a12tf_ci - ((1/Soucastky(ii-1))*a22tf_ci*Ks);
                a12_ci = tfdata(a12tf_ci,'v');
                a12_ci = deconv(a12_ci,axx_jm);  % Novy citatel a12 po odstepeni aktualniho polu (vykraceni)
                a12tf_ci = tf(a12_ci,[1]);  % Novy citatel a12 v transformovanem tvaru
                a12_jm = deconv(a12_jm,axx_jm);  % Novy jmenovatel a12 po odstepeni aktualniho polu
                ii = ii + 1;
            end
            Soucastky(ii) = a21_ci(1); % Zbyly pricny C
            % Zapojeni tedy zacina pricnym C, prvky maji stejne normovane hodnoty jako u predesleho zapojeni    
end
